/* $Id: ReadWave.java,v 1.2 2016/02/12 23:56:25 mit3 Exp $ */
/* ReadWave.java v0.3 */
import java.io.*;
import java.net.*;

public class ReadWave {
    private static boolean EndOfFile;
    private static int Maxdt;
    private static int Samplf;
    private static int Cnt;
    private static int[] Data;
    private static short Channel, Bsize;
    private static String Label;
    private static String Error;
    private static BufferedInputStream buf;
    private static InputStream in;
    private static DataInputStream data;

    public ReadWave() {}
    public ReadWave(URL url) {
	try {
	    Error = "";
	    EndOfFile = false;
            in = url.openStream();
            buf = new BufferedInputStream(in);
	    data = new DataInputStream(buf);

	    this.readChunk();
	    this.readData();
        }
        catch (FileNotFoundException e) {
            Error = "Error opening file";
        }
        catch (IOException e) {
            Error = "Can not open";
        }
	catch (VirtualMachineError OutOfMemoryException) {
            Error = "Out of memory";
        }
    }
    public static int[] getData() {
        return Data;
    }
    public static int getData(int num) {
        return Data[num];
    }
    public static int getSamplf() {
        return Samplf;
    }
    public static int getCount() {
	return Cnt;
    }
    public static String getLabel() {
	return Label;
    }
    public static String getError() {
	return Error;
    }
    public static String getChannel() {
	return (Channel == 2) ? "Stereo" : "Mono";
    }
    public String toString() {
	return Label+" "+this.getChannel()+" "+Bsize+" "+
 	    Samplf+" "+Cnt;//+"("+Maxdt+")";
    }

    public static void readChunk() {
	byte[] fact = new byte[4];
	byte[] rbit = new byte[2];
	int skip;
	String chunk;
	try {
	    Label = "<mono>";         // 44 mono
            data.skip(12);
            data.read(fact);          // type check 
            chunk = new String(fact); 
            data.read(fact);
            skip = btoi(fact);
            if (!chunk.equals("fmt ")) { // 76 stereo
                data.skip(skip+8);
                Label = "<WAVE>";
		Channel = 2;
            }
	    data.skip(2);
            data.read(rbit);       // channel
            Channel = btos(rbit);
            data.read(fact);       // splngf
            Samplf = btoi(fact);
            data.skip(6);
            data.read(rbit);       // bits
            Bsize = btos(rbit);
            if (skip == 18)        // 58 makewave
                data.skip(2);
            data.read(fact);
	    chunk = new String(fact);
            if (chunk.equals("fact")) { // 58 makewave
                data.skip(12);
                Label = "<fact>";
            } else if (!chunk.equals("data")) { 
                Error = "<"+chunk+"> ?";
                return;
            }
            if (Bsize != 16) {
                Error = "Sorry. 16bit only";
                return;
            }
            data.read(fact);      // max data
            Maxdt = btoi(fact);
            if (Channel == 2)
		Maxdt /= 2;

	    //System.out.println("maxdt:"+Maxdt+" spl:"+Samplf+" Bsize:"+Bsize);
	}
	catch (EOFException EndOfFileException) {
            EndOfFile = true;
        }
        catch (IOException ReadError) {
            Error = "Error reading file";
        }
    }

    public static void readData() {
	Data = new int[Maxdt];
	int lft, rit;
	Cnt = 0;
	try {
	    while (!EndOfFile) {
		if (Channel == 2) { // stereo
		    lft = bgtolt(data.readShort());
		    rit = bgtolt(data.readShort());
		    Data[Cnt++] = (lft+rit)/2;
		} else {           // mono
		    Data[Cnt++] = bgtolt(data.readShort());
		}
	    }
	}
	catch (EOFException EndOfFileException) {
            EndOfFile = true;
        }
        catch (IOException ReadError) {
            Error = "Error reading file";
        }
	finally {
            try {
                in.close();
            }
            catch (Exception e) {}
        }
    }
    public static short bgtolt(short dt) {
	return (short)((dt & 0x00ff) << 8 | (dt & 0xff00) >> 8);
    }
    public static short btos(byte[] in) {
	return (short)(((in[1] & 0xff) << 8) | (in[0] & 0xff));
    }
    public static int btoi(byte[] in) {
	return ((in[3] & 0xff) << 24) | ((in[2] & 0xff) << 16) |
	    ((in[1] & 0xff) << 8) | (in[0] & 0xff);
    }
}
