/* $Id: dft.java,v 1.18 2016/02/13 08:23:21 mit3 Exp $
/* v0.1.1 */
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.text.DecimalFormat;

public class dft extends Applet
    implements ActionListener, ItemListener, AdjustmentListener,
	       Runnable, MouseListener, MouseMotionListener
{
    private Button btPV;    // +
    private Button btMV;    // -
    private Button btPF;    // >
    private Button btMF;    // <
    private Button btADJ;
    private Button btQ;
    private Button btWest[];
    private Choice chTau;
    private Choice chSmplf;
    private Choice chFile;  // wave file
    private Scrollbar slbRr;
    private Scrollbar slbWide;
    private TextField tfInput;
    private TextField tfOutput;
    private TextField tfDelta;
    private TextField tfFile;
    private Canvas can;
    private Graphics gi;
    private Image ig;
    private Panel PN, PE, PW, PS;
    private DecimalFormat df2, df1, df0;
    private Font Fnt;
    private FontMetrics fm;
    private static final long serialVersionUID = 1L;

    private final int WAVE = 0; // Grap.
    private final int WIND = 1;
    private final int DFT_ = 2;
    private final double PI2 = Math.PI*2;

    private int GRAP = WAVE;
    private int Splngf = 8000;    
    private int FNT;

    private String Dirnm; // wave file
    private String Error;
    private String AFormat;
    private int AllFile;
    private int WaveSize;
    private int Count;

    private int W, H, H2, HB, BASE;
    private double WD;
    private double Wby;  // wave h
    private double Dby;; // dft h
    private double R = 1.0;
    private double NR;
    private double SAmax = 1.4;
    private double SAmin = 0.7;
    private double SAmid = 1.0;
    private double TAU = 1.0;
    private double DELTA = 0.01;    
    private int N0; // 5
    private int NN; // 5^2 => 32
    private int N2; // 32/2 => 16
    private int NR0;
    private int Wdft = 2;
    private int Start = 0;
    private int LOOP = 0;
    private int StartMX;
    private int LastMX;
    private double[] Hanning;
    private double[] Spec;
    private double[] Re;
    private double[] Im;
    private double[] Bins;
    private double[] SA;
    private double[] SAR;
    private String[] Filenm;
    private String tau[] = {"/1", "/2", "/4", "/8"};
    private String Wests[] = {"Wave", "Window", "DFT"};
    private String smplf[] = {"5", "6", "7", "8"};
    private boolean DftSW;
    private boolean AdjSW;
    private boolean DragSW;
    private boolean QQ;

    private ReadWave RW;
    private Thread thr;

    public void init() {
	N0 = 5;
	calcSmplf();

        buildLayout();

	df2 = new DecimalFormat("#0.0####");
	df1 = new DecimalFormat("#0.0##");
	df0 = new DecimalFormat("#0");
    }
    public void calcSmplf() {
	NN = (int)Math.pow(2, N0); // 2^n
        N2 = NN/2;

	setNR();
    }
    public void start() {
        W = getCanvasD().width;
        H = getCanvasD().height;

	FNT = 12;
	H2 = H/2;
	HB = (int)(H*2/3.0);
	BASE = H-FNT*3;
	Wby = HB/(double)Short.MAX_VALUE;
	Dby = 0.1;

        can.setSize(W, H);
        ig = createImage(W, H);
        gi = ig.getGraphics();

	RW = new ReadWave();

        if (isFile())
            select_file();
    }
    //
    public boolean isFile() {
        return (AllFile > 0);
    }
     public void select_file() {
        read_file(chFile.getSelectedItem());
    }
    public void read_file(String fn) {
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR)); // 
        read_data(Dirnm+fn);
	
	if (!Error.equals(""))
	    tfFile.setText(Error);
	else if (WaveSize < 1) {
	    Error = "File is null.";
	    Count = 0;
	    Start = 0;
	} else {
            Start = 0;
            Count = WaveSize;
	    initWide();
	    R = TAU*SAmid;

	    setRr();
	    Wdft = 2;

            DftSW = false;
	    AdjSW = false;
	}
        setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    }
    public void read_data(String fname) {
        try {
            URL url = new URL(getDocumentBase(), fname);
            RW = new ReadWave(url);

            Splngf = RW.getSamplf();
            WaveSize = RW.getCount();
            String label = RW.getLabel();
            Error = RW.getError();
            AFormat = RW.toString();

	    tfFile.setText(label+" ,"+Splngf+" Hz,"+WaveSize+" bytes");
        } catch(Exception e) {
            Error = "File read error.";
        }
    }
    //
    public Dimension getCanvasD() {
        Dimension dn = PN.getSize();
        Dimension ds = PS.getSize();
        Dimension de = PE.getSize();
        Dimension dw = PW.getSize();
        Dimension da = getSize();
        int cw = da.width-(de.width+dw.width);
        int ch = da.height-(ds.height+dn.height);
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void buildLayout() {
	String fnt = getParameter("font");
        FNT = (fnt != null) ? Integer.parseInt(fnt) : 12;
        Fnt = new Font("SansSerif", Font.PLAIN, FNT);
        setFont(Fnt);
        fm = getFontMetrics(Fnt);

	setLayout(new BorderLayout());

        PN = new Panel();
        PN.setLayout(new FlowLayout());
	PN.setLayout(new GridLayout(2,1,0,0));
        add(PN, "North");

	Panel n0 = new Panel();
	n0.setLayout(new FlowLayout());
        PN.add(n0);

	Panel n1 = new Panel();
        n1.setLayout(new FlowLayout());
        PN.add(n1);

	chSmplf = new Choice();
	for (int i = 0; i < smplf.length; i++)
            chSmplf.addItem(smplf[i]);
        chSmplf.addItemListener(this);
        n0.add(chSmplf);

	int max = (int)(SAmax*100)+1;
	int min = (int)(SAmin*100);
	int mid = (int)(SAmid*100);
	slbRr = new Scrollbar(Scrollbar.HORIZONTAL, mid, 1, min, max);
	slbRr.addAdjustmentListener(this);
        n0.add(slbRr);

	chTau = new Choice();
	for (int i = 0; i < tau.length; i++)
	    chTau.addItem(tau[i]);
	chTau.addItemListener(this);
	n0.add(chTau);

	tfDelta = new TextField(9);
        tfDelta.setEditable(true);
        n0.add(tfDelta);
	tfDelta.addActionListener(this);

	btADJ = new Button("Adjust");
        n0.add(btADJ);
        btADJ.addActionListener(this);

	String fn = getParameter("all_f");
        AllFile = (fn == null) ? 0 : Integer.parseInt(fn);
        if (AllFile == 0)
	    Error = "No wave file.";
        Filenm = new String[AllFile];  // max files
        Dirnm = getParameter("dirnm");
        Dirnm = (Dirnm == null) ? "" : Dirnm;
        chFile = new Choice();
        for (int i = 0; i < AllFile; i++) {
            Filenm[i] = getParameter("wave"+i);
            chFile.addItem(Filenm[i]);
        }
        n0.add(chFile);
        chFile.addItemListener(this);
	//

	tfInput = new TextField(24);
        tfInput.setEditable(false);
        n1.add(tfInput);

	tfFile = new TextField(24);
	tfFile.setEditable(false);
	n1.add(tfFile);
	//---

        PE = new Panel();
        PE.setLayout(new GridLayout(5,1,0,0));
        add(PE, "East");

	btPV = new Button("+");
        PE.add(btPV);
        btPV.addActionListener(this);

        btMV = new Button("-");
        PE.add(btMV);
        btMV.addActionListener(this);

        PE.add(new Label(""));

        btPF = new Button(">");
        PE.add(btPF);
        btPF.addActionListener(this);

        btMF = new Button("<");
        PE.add(btMF);
        btMF.addActionListener(this);
        //---

        PW = new Panel();
        PW.setLayout(new GridLayout(5,1,0,0));
        add(PW, "West");

	btWest = new Button[Wests.length];
	for (int i = 0; i < Wests.length; i++) {
	    btWest[i] = new Button(Wests[i]);
	    btWest[i].addActionListener(this);
            PW.add(btWest[i]);
        }

	//btQ = new Button("(Q)");
	//PW.add(btQ);
	//btQ.addActionListener(this);
	//---

        PS = new Panel();
        PS.setLayout(new GridLayout(1,2,0,0));
        add(PS, "South");

	tfOutput = new TextField(20);
	tfOutput.setEditable(false);
	PS.add(tfOutput);

	slbWide = new Scrollbar(Scrollbar.HORIZONTAL, 0, 1, 0, 100);
	slbWide.addAdjustmentListener(this);
        PS.add(slbWide);
	//---

        can = new MyCanvas();
        add(can, "Center");

        can.addMouseListener(this);
        can.addMouseMotionListener(this);
    }
    public void setEnabled() {
	boolean n5 = (N0 == 5);
	btADJ.setEnabled(n5);
    }
    public void actionPerformed(ActionEvent e){
	for (int i = 0; i < Wests.length; i++) {
	    if (e.getSource() == btWest[i]) {
		GRAP = i;
		break;
	    } 
	}
	if (e.getSource() == btQ)
	    setQ();

        else if (e.getSource() == btPV) // +
            setGain(true);
        else if (e.getSource() == btMV) // -
            setGain(false);

        else if (e.getSource() == btPF) // >
            setWide(true);
        else if (e.getSource() == btMF) // <
            setWide(false);
	else if (e.getSource() == btADJ)
	    startRun();

	else if (e.getSource() == tfDelta)
	    textInput();
 
	can.repaint();
    }
    public void setQ() {
	QQ = !QQ;
	btQ.setLabel(QQ ? "(q)" : "(Q)");

	DftSW = false;
    }
    public void startRun() {
	if (thr == null & N0 == 5) {
	    int sa = calcSa();
	    SA = new double[sa];
	    SAR = new double[sa];
	    setNR();
	    AdjSW = false;

	    setAdjustButton(false);
	    thr = new Thread(this);
	    thr.start();
        } else {
            thr = null;
        }
    }
    public void setAdjustButton(boolean sw) {
	btADJ.setLabel(sw ? "Adjust" : " Stop "); 
    }
    public void run() {
	int stime = 10;

	setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR)); // 
	try {
	    int sa = calcSa();
	    LOOP = 0;

	    for (int i = 0; i < sa; i++) {
		if (thr == null)
		    break;
		R = TAU*SAmin+i*DELTA;
		setNR();

		can.repaint();
		thr.sleep(stime);
		LOOP++;
	    }
	    double[] max = getSAmax();
	    R = max[1];
	    setNR();

	    AdjSW = true;
	    can.repaint();
	} catch (InterruptedException e) {
            Error = "Run error.";
	}
	setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	thr = null;
	setAdjustButton(true);
    }
    public int calcSa() {
	int sa = (int)(TAU*(SAmax-SAmin)/DELTA);

	return sa;
    }
    public void stop() {
        if (thr != null)
            thr = null;
    }
    public void setWide(boolean sw) {
	switch (GRAP) {
        case WAVE:
            Count = sw ? Count/2 : Count*2;
	    if (Count > WaveSize) {
		Count = WaveSize;
		StartMX = 0;
	    } else if (Count < NR0)
		Count = NR0;
	    initWide();
            break;
        case DFT_:
	    Wdft = sw ? Wdft/2 : Wdft*2;
	    if (Wdft > 512)
		Wdft = 512;
	    else if (Wdft < 2)
		Wdft = 2;
            break;
	     default:
        }
    }
    public void setGain(boolean sw) {
        switch (GRAP) {
        case WAVE:
	case WIND:
            Wby = sw ? Wby*2 : Wby/2;
            break;
        case DFT_:
	    Dby = sw ? Dby*2 : Dby/2;
            break;
        default:
        }
    }
    public void itemStateChanged(ItemEvent e) {
	if (e.getSource() == chSmplf) {
            String sp = chSmplf.getSelectedItem();
            N0 = Integer.parseInt(sp);
            calcSmplf();
	    setEnabled();
	}
	if (e.getSource() == chFile) {
	    select_file();
	}

	if (e.getSource() == chTau) {
	    setScrollTau();
	}
	
	DftSW = false;
	can.repaint();
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
        if (e.getSource() == slbRr)
            setRr();

	if (e.getSource() == slbWide)
	    setWaveWide();

        can.repaint();
    }
    public void setWaveWide() {
	Start = slbWide.getValue();
	DftSW = false;
    }
    public void initWide() {
	if (Start+Count > WaveSize)
	    Start = WaveSize-Count;
	if (Start < 0)
	    Start = 0;
	slbWide.setValues(Start, Count, 0, WaveSize);
	slbWide.setBlockIncrement((int)(NR0/2.0));
        slbWide.setUnitIncrement(1);
    }
    public void setNR() {
	NR = R*NN;
	NR0 = (int)NR;

	DftSW = false;
    }
    public void setRr() {
	R = slbRr.getValue()/100.0;

	setNR();
    }
    public void setScrollTau() {
	TAU = (int)Math.pow(2, chTau.getSelectedIndex());

	int min = (int)(SAmin*TAU*100);
	int max = (int)(SAmax*TAU*100)+1;
	int mid = (int)(SAmid*TAU*100);
	slbRr.setValues(mid, 1, min, max);

	setRr();
	AdjSW = false;
    }
    public void textInput() {
	String in = tfDelta.getText();
	try {
            double del = Double.valueOf(in).doubleValue();
	    if (del < 0.0)
                tfDelta.setText("?");
	    else {
		R = del;
		setNR();
	    }
	}
	catch(NumberFormatException e) {
	    tfDelta.setText("!");
        }

	can.repaint();
    }
    public void mouseMoved(MouseEvent m) {
	//showStatus("m: "+m.getX()+" : "+calcCount(m.getX()) );
    }
    public void mousePressed(MouseEvent m) {
	StartMX = m.getX();
	if (StartMX < 0)
	    StartMX = 0;
	can.repaint();
    }
    public void mouseReleased(MouseEvent m) {
	LastMX = m.getX();
	if (LastMX > W)
	    LastMX = W;
	DragSW = false;
	checkMX();
	can.repaint();
    }
    public void mouseDragged(MouseEvent m) {
	DragSW = true;
	LastMX = m.getX();
	if (LastMX < 0)
	    LastMX = 0;

	//showStatus("d: "+m.getX()+" : "+calcCount(m.getX()) );
	can.repaint();
    }
    public void mouseEntered(MouseEvent m) {}
    public void mouseExited (MouseEvent m) {}
    public void mouseClicked(MouseEvent m) {}
    public void checkMX() {
	int tmp;
	if (StartMX > LastMX) {
	    tmp = StartMX;
	    StartMX = LastMX;
	    LastMX = tmp;
	}

	int st = Start+calcCount(StartMX);
	int mx = calcCount(LastMX-StartMX);
	if (mx >= NR0) {
	    Start = st;
	    Count = mx;

	    initWide();
	}
    }
    public int calcCount(int mx) {
	return (int)(mx/WD);
    }
    //------------------------

    class MyCanvas extends Canvas {
        private static final long serialVersionUID = 1L;
        public void update(Graphics g) {
            can.paint(g);
        }
        public void paint(Graphics g) {
            paintI();
            g.drawImage(ig, 0, 0, this);
        }
    }

    public void backBlack(Graphics g) {
        g.setColor(Color.black);
        g.fillRect(0, 0, W, H);
    }
    public void paintI() {
	int[] wav = new int[NR0];
	if (!DftSW) {
	    for (int i = 0; i < NR0; i++) {
		wav[i] = RW.getData(Start+i);
	    }
	    initHanning();
	    calcDft(wav);

	    if (N0 == 5 & !QQ)
	    	calcBins();
	}
	WD = (double)W/Count;
	backBlack(gi);
	dispText();

	switch (GRAP) {
        case WAVE:
	    dispWave(gi);
	    break;
	case WIND:
	    dispWindow(gi);
	    break;
        case DFT_:
	    dispDft(gi);
	    if (AdjSW == true)
		dispAdjust(gi);
	    break;
	default:
        }

	dispAdjustFreq(gi);
    }
    //
    public void dispText() {
	tfInput.setText(dform2(R)+" : "+
			dform2(calcRfreq(R))+"[Hz]" );
    }
    //
    public void dispAdjust(Graphics g) {
	dispAdjustMemori(g);

	int x, y, sa = SA.length;
	double dx = (double)(W-1)/sa;
	double[] max = getSAmax();
	double dy = BASE/max[0];
	int dot = (dx < 2) ? 2 : (int)dx;
	int d0 = dot/2;
	
	g.setColor(Color.magenta);
	for (int i = 0; i < sa; i++) {
	    x = (int)(dx*i-d0);
	    y = (int)(BASE-SA[i]*dy);
	    g.fillOval(x, y, dot, dot);
	}

	dispAdjustValue(g, max[0]);
    }
    public void dispAdjustValue(Graphics g, double max) {
	double dy = BASE/10.0;
	double dmax = max/10;
	int y;
 
	g.setColor(Color.gray);
	for (int i = 0; i < 10; i++) {
	    y = (int)(BASE-dy*i);
	    g.drawLine(W, y, W-15, y);

	    g.drawString(dform(dmax*i), W-30, y);
	}
    }
    public double[] getSAmax() {
	int x = 0, sa = SA.length;
	double[] max = new double[2];
	for (int j = 0; j < sa; j++) {
	    if (max[0] < SA[j]) {
		max[0] = SA[j];
		x = j;
	    }
	}
	max[1] = SAR[x];
	return max;
    }
    public void dispAdjustFreq(Graphics g) {
	double max = calcRfreq(TAU*SAmax);
	double min = calcRfreq(TAU*SAmin);

	g.setColor(Color.white);
	g.drawString(dform0(max)+"---"+dform0(min)+"[Hz]",
		     W/4, FNT);
    }
    public double calcRfreq(double r) {
	return (Math.pow(2.0, N0-4)*Splngf)/(r*NN);
    }
    public void dispAdjustMemori(Graphics g) {
	dispCenterLine(g, BASE);
	
	int x, sa = SA.length;
	double samin = SAmin*TAU;
	double dx = (double)W/sa;

	for (int i = 0; i < sa; i++) {
	    x = (int)(dx*i);
	    if (i%100 == 0) {
		g.setColor(Color.gray);
		g.drawLine(x, BASE, x, BASE+20);

		dispR(g, x, i);
	    } else if (i%50 == 0) {
		g.setColor(Color.gray);
		g.drawLine(x, BASE, x, BASE+15);

		dispR(g, x, i);
	    } else if (i%10 == 0) {
		g.setColor(Color.gray);
		g.drawLine(x, BASE, x, BASE+10);
		if (TAU < 4) {
		    dispR(g, x, i);
		}
	    } else {
		if (sa < 200) {
		    g.setColor(Color.gray);
		    g.drawLine(x, BASE, x, BASE+5);
		}
	    }
	}
    }
    public void dispR(Graphics g, int x, double i) {
	double del = SAmin*TAU+DELTA*i;
	g.setColor(Color.pink);
	g.drawString(dform(del), x, BASE+FNT*2);
    }
    //
    public void dispWave(Graphics g) {
	dispCenterLine(g, H2);
	dispWaveTime(g);
	if (!isFile())
            return;

	int x, y, x0 = 0, y0 = 0, val;
	//double wd = (double)W/Count;
	int max = Integer.MIN_VALUE;
        int min = Integer.MAX_VALUE;

	for (int i = 0; i < Count; i++) {
	    val = RW.getData(i+Start);
	    x = (int)(WD*i);
	    y = (int)(H2-Wby*val);
	    g.setColor((i < NR0) ?  Color.orange : Color.green);
	    //g.drawLine(x, y, x, y);

	    if (i == 0) {
		x0 = x;
                y0 = y;
            }
	    g.drawLine(x0, y0, x, y);
	    x0 = x;
            y0 = y;

	    max = Math.max(max, val);
            min = Math.min(min, val);
	}

	dispWaveValue(g, min, max);
	if (DragSW)
            dispCursor(g);
    }
    public void dispCursor(Graphics g) {
	int len = Math.abs(calcCount(StartMX)-calcCount(LastMX));
	g.setColor((len < NR0) ? Color.magenta : Color.white);

        g.drawLine(StartMX, 0, StartMX, BASE);
        g.drawLine(LastMX, 0, LastMX, BASE);
    }
    public void dispWaveTime(Graphics g) {
	dispCenterLine(g, BASE);

	double tim, allsec = Count/(double)Splngf;

        if (allsec < 0.1)
            tim = 0.01;
        else if (allsec < 0.3)
            tim = 0.05;
        else if (allsec < 1)
            tim = 0.1;
        else if (allsec < 3)
            tim = 0.5;
        else if (allsec < 10)
            tim = 1;
        else if (allsec < 30)
            tim = 5;
        else if (allsec < 60)
            tim = 10;
        else
            tim = 60;

        String s = "[sec] ";
        g.setColor(Color.yellow);
        g.drawString(s, W-fm.stringWidth(s), H-1);

        double asec = tim/(allsec/W);
        int maxsec = (int)(allsec/tim);
        if (maxsec > 0) {
            int ss = H-FNT;
            int x, l = 5;
            for (int i = 0; i <= maxsec; i++) {
                x = (int)(asec*i);

                g.setColor(Color.gray);
                g.drawLine(x, BASE, x, BASE+l);

                g.setColor(Color.yellow);
                g.drawString(dform(i*tim), x, ss);
            }
        }
    }
    public void dispWaveValue(Graphics g, int min, int max) {
        g.setColor(Color.lightGray);
        g.drawString(dform(100*max/Short.MAX_VALUE), 1,
		     (int)(H2-max*Wby));
        g.drawString(dform(100*min/Short.MAX_VALUE), 1,
		     (int)(H2-min*Wby+FNT));
        g.drawString("[%]", 1, FNT);
    }

    public void dispCenterLine(Graphics g, int h) {
	g.setColor(Color.darkGray);
	g.drawLine(0, h, W, h);
    }
    //
    public void dispWindow(Graphics g) {
	dispCenterLine(g, H2);
	dispWindowMemori(g);
	if (!isFile())
            return;

	int x = 0, y = 0, x0, y0;
	double wd = (double)W/NR0;
	double[] wind = new double[NR0];

	for (int i = 0; i < NR0; i++) {
	    wind[i] = Hanning[i]*RW.getData(i+Start);
	}

	g.setColor(Color.orange);
	for (int i = 0; i < NR0; i++) {
	    x0 = (int)(wd*i);
	    y0 = (int)(H2-Wby*wind[i]);
	    if (i == 0) {
		x = x0;
		y = y0;
	    }
	    g.drawLine(x, y, x0, y0);
	    x = x0;
	    y = y0;
	}
    }
    public void dispWindowMemori(Graphics g) {
	dispCenterLine(g, BASE);
	g.setColor(Color.orange);
	g.drawString(dform(NR), 5, BASE+FNT*3);
	
	double wd = (double)W/NR0;
	int x;

	g.setColor(Color.gray);
	for (int i = 0; i < NR0; i++) {
	    x = (int)(wd*i);
	    if (i%100 == 0) {
		g.drawLine(x, BASE, x, BASE+18);
		g.drawString(""+i, x, BASE+FNT*2);
	    } else if (i%50 == 0) {
		g.drawLine(x, BASE, x, BASE+15);
		g.drawString(""+i, x, BASE+FNT*2);
	    } else if (i%10 == 0) {
		g.drawLine(x, BASE, x, BASE+12);
		if (NR0 < 150)
		    g.drawString(""+i, x, BASE+FNT*2);
	    } else {
		if (NR0 < 100)
		    g.drawLine(x, BASE, x, BASE+7);
	    }
	}
    }
    //
    public void dispDft(Graphics g) {
	dispDftMemori(g);

	int x1, y1 = 0;
	double max = NR/Wdft;
	double dw = (W-1)/max;
	int max0 = (int)max;
	int ww = (dw < 2) ? 1 : 2;
	double[] val = new double[NR0];

	if (N0 == 5 & !QQ)
	    val = Bins;
	else
	    val = Spec;

	g.setColor(Color.green);
	for (int i = 0; i < max0; i++) {
	    x1 = (int)(i*dw);
	    y1 = (int)(val[i]*Dby);

	    if (y1 < 0.0)
		g.drawRect(x1, HB, ww, Math.abs(y1));
	    else
		g.drawRect(x1, HB-y1, ww, y1);
	}
    }
    public void dispDftMemori(Graphics g) {
	dispCenterLine(g, HB);
	
	int max = (int)(Splngf/Wdft);
	double ds = (double)(W-1)/max;
	int me, di;
	
        for (int i = 0; i < max; i += 10) {
            di = (int)(ds*i);
            if (i%5000 == 0){
                if (max >= 5000)
                    disp_k(g, i, di);
                me = 17;
            } else if (i%1000 == 0){
                if (max < 12000)
                    disp_k(g, i, di);
                me = 15;
            } else if (i%500 == 0) {
                if (max > 23000)
                    continue;
                me = 11;
            } else if (i%100 == 0) {
                if (max > 12000)
                    continue;
                me = 8;
            } else if (max < 2000){
                me = 5;
            } else
                continue;
            g.setColor(Color.gray);
            g.drawLine(di, HB, di, HB+me);
        }
    }
    public void disp_k(Graphics g, int k, int x) {
        g.setColor(Color.orange);
        g.drawString(k/1000+"k", x, HB+FNT*2);
    }
    //
    public void calcBins() {
	int nr2 = NR0/2;
	Bins = Spec;
	double sm0 = 0, sm1 = 0;

	for (int i = 1; i < nr2-1; i++) {
	    Bins[i] = (i%2 == 0) ? Spec[i] :
		Spec[i]-(Spec[i-1]+Spec[i+1])/2.0;
	}

	for (int j = 1; j < nr2; j++) {
	    if (j%2 == 0)
		sm1 += Math.abs(Bins[j]);
	    else
		sm0 += Math.abs(Bins[j]);
	}

	dispOutput(sm0, sm1);
    }
    //
    public void dispOutput(double s0, double s1) {
	double sa = s1/s0;
	double[] max = new double[2];
	if (AdjSW == true)
	    max = getSAmax();

	tfOutput.setText("=>: "+dform2(sa)+
			 " (max: "+dform(max[0])+")" );
	if (thr != null) {
	  SA[LOOP] = sa;
	  SAR[LOOP] = R;
	}
    }
    public String dform0(double val) {
    	return df0.format((float)val);
    }
    public String dform(double val) {
        return df1.format((float)val);
    }
    public String dform2(double val) {
        return df2.format((float)val);
    }
    //
    public void calcDft(int[] wa) {
	Spec = new double[NR0];
        Re = new double[NR0];
        Im = new double[NR0];

	dft(hanning(wa));
	DftSW = true;
    }
    public void initHanning() {
	Hanning = new double[NR0];

	double lps1 = 1.0/(NR0-1);
	for (int i = 0; i < NR0; i++) {
	    Hanning[i] = 0.5-0.5*Math.cos(PI2*i*lps1);
	}
    }
    public double[] hanning(int[] wa) {
	double[] ha = new double[NR0];

	for (int i = 0; i < NR0; i++) {
            ha[i] = Hanning[i]*wa[i];
	}
	return ha;
    }	
    public void dft(double[] wa) {
	double deg = PI2/NR;
	double g; 
	for (int i = 0; i < NR0; i++) {
	    Re[i] = 0.0;
	    Im[i] = 0.0;
	    for(int j = 0; j < NR0; j++) {
		g = -1.0*i*deg*j;
		Re[i] += wa[j]*Math.cos(g);
		Im[i] += wa[j]*Math.sin(g);
	    }
	    Spec[i] = Math.sqrt(Re[i]*Re[i]+Im[i]*Im[i])/NR;
	}
    }
}
